#--Estimate causes of external war--
#setwd("/home/anthon/Dropbox/wes")
setwd("e:/Dropbox/wes")
#setwd("/home/eaeff/mi/")
rm(list=ls(all=TRUE))
options(echo=TRUE)
library(foreign)
library(AER)
library(mice)
library(spdep)
library(relaimpo)
library(Hmisc)
library(psychometric)
library(gplots)
library(vegan)
library(forward)
library(psych)
library(geosphere)

sessionInfo()
ls()

stm<-"EffRouton"

gSimpStat<-function(ww){
a<-data.frame(psych::describe(ww))  
a<-round(a[,c(2:5,8:9,11:12)],3)
return(a)
}

kln<-function(bgg){
print(sapply(bgg,function(x) class(x)))
z<-which(sapply(bgg,function(x) class(x))=="factor")
bgg[,z]<-sapply(bgg[,z],function(x) as.character(x))
return(bgg)
}

klnN<-function(bgg){
print(sapply(bgg,function(x) class(x)))
z<-which(sapply(bgg,function(x) class(x))=="factor")
bgg[,z]<-sapply(bgg[,z],function(x) as.numeric(as.character(x)))
return(bgg)
}

Atf<-function(a1,a2,a3){
print(a1)
write.table(a1,file=paste(a2,".csv",sep=""),quote=TRUE,sep=",",dec=".",qmethod="double",
col.names = NA,row.names = TRUE,append=a3)
}


#---------prepare data----------
ii<-"v1650"  # external war

uxx<-read.csv("ModelVarbs.csv",as.is=TRUE)
rownames(uxx)<-uxx$varb

indpv<-c("v814", "v815", "v816", "v817", "v818", "v819", "pdens", 
"v17", "v81", "v238", "v826", "v149", "v787", "v757", "v575", 
"v236", "metal", "v93.SubsProd", "v93.WarWealth", 
"v93.Slaves", "v93.FreeContrib", "v93.LargeLand", 
"v93.PoliOffice", "v93.ForgnCommerce", "v93.CapitalistEnt", 
"v93.PriestlyServ", "mht.Taiga", "mht.Xeric", "mht.Maquis", 
"mht.MountGrass", "mht.SnowIceRock", "mht.TempBroadLeaf", 
"mht.TempConif", "mht.TempGrass", "mht.TropSubDryBroadLeaf", 
"mht.TropSubGrass", "mht.TropSubWetBroadLeaf", "mht.Tundra", 
"v814pdens", "v815pdens", "v816pdens", "v817pdens", 
"v818pdens", "v819pdens", "v63", "v1874", "v819.2", "v236.2", 
"v81.3", "v814.2")

othexog<-c("bio.1","bio.2","bio.3","bio.4","bio.5","bio.6","bio.7","bio.8","bio.9",
"bio.10","bio.11","bio.12","bio.13","bio.14","bio.15","bio.16","bio.17",
"bio.18","bio.19","meanalt","medianalt","sdalt","CValt")

xvv<-c("pdens", "v238", "v149", "v787", "v236", "metal", 
"v93.WarWealth", "v93.CapitalistEnt", "mht.Taiga", 
"mht.TempBroadLeaf", "v814pdens", "v815pdens", "v816pdens", 
"v817pdens", "v818pdens", "v819pdens", "v236.2", "v81.3", 
"v81", "v814.2", "mht.TempConif", "v814")

indpv<-unique(c(indpv,xvv))

load("idata.Rdata",.GlobalEnv)
load(file="sccsA.Rdata",.GlobalEnv)
table(diff(sccsA$ord))

fff<-idata[order(idata$.imp,idata$.id),]
zdv<-which(!is.na(sccsA[,ii]))
z<-sapply(zdv,function(x) which(fff$.id==x))
fff<-fff[z,]
table(table(fff$.imp));table(table(fff$.id))
dim(fff)
k<-names(fff)

nimp<-max(fff$.imp)
table(sapply(fff,function(x) class(x)))
k[which(sapply(fff[,k],function(x) class(x))=="factor")]

putt<-k[which(sapply(fff[,k],function(x) class(x))!="factor")]
putt<-putt[which(!is.na(match(putt,names(sccsA))))]

#--make metal and plow (before scaling)---
u<-cbind((as.numeric(as.character(fff$v248))<9)*1,(as.numeric(as.character(fff$v254))<9)*1,
          (as.numeric(as.character(fff$v153))>=4)*1,(as.numeric(as.character(fff$v140))>0)*1)
fff$metal<-apply(u,1,mean)
multilevel::cronbach(u)
table(fff$metal)
a<-princomp(scale(u))
(a$sdev^2)/sum(a$sdev^2)

u<-cbind((as.numeric(as.character(fff$v243))>1)*1,(as.numeric(as.character(fff$v858))==12)*1,(as.numeric(as.character(fff$v1127))==2)*1)
fff$plow<-apply(u,1,mean)
multilevel::cronbach(u)
table(fff$plow)

fff$v93<-factor(fff$v93,levels=0:9,
          labels=c("SubsProd","WarWealth","TribTax","Slaves","FreeContrib","LargeLand","PoliOffice",
         "ForgnCommerce","CapitalistEnt","PriestlyServ") )
fff$mht.name<-factor(fff$mht.name,levels=levels(fff$mht.name),
          labels=c("Taiga","Xeric","FloodGrass","Maquis","MountGrass","SnowIceRock","TempBroadLeaf",
         "TempConif","TempGrass","TropSubConif","TropSubDryBroadLeaf","TropSubGrass",
         "TropSubWetBroadLeaf","Tundra","Water") )
table(fff$v93)
table(fff$mht.name)

#--make dummies from categorical variables--
pot<-fff[,c(".id",".imp")]
for (kk in c("v93","mht.name")){
a<-unique(fff[,kk])
a<-a[order(a)]
b<-matrix(a,NROW(fff),length(a),byrow=TRUE)
c<-data.frame((b==fff[,kk])*1)
names(c)<-paste(substr(kk,1,3),a,sep=".")
z<-which(colSums(c)!=min(colSums(c)))
pot<-cbind(pot,c[,z])
}
pot<-pot[,-(1:2)]
fff<-cbind(fff,pot)

#---Normalize (m=0 s=1) all numeric, by imp--------
putt<-c(putt,"metal")
for (j in 1:nimp){
z<-which(fff$.imp==j)
for (xi in putt){
fff[z,xi]<-scale(fff[z,xi])  
fff[z,paste(xi,2,sep=".")]<-fff[z,xi]^2
fff[z,paste(xi,3,sep=".")]<-fff[z,xi]^3
}
}

#--pdens was endogenous, so will make instrument--
iv4p<-unique(c(indpv[which(is.na(match(indpv,indpv[agrep("pdens",indpv)])))],othexog))
fff$pdens<-apply((fff[,c("v64","v156","v1130")]),1,mean)
ifp<-formula(paste("pdens~",paste(iv4p,collapse="+"),sep=""))
fff$ix<-fff$pdens
for (j in 1:nimp){
z<-which(fff$.imp==j)
fff$pdens[z]<-scale(lm(ifp,data=fff[z,])$fitted.values)
}

cor(fff[,c("pdens","v64","v156","v1130","ix")])^2
cor(fff[,c("pdens","v64","v156","v1130","ix")])
describe(fff[,c("pdens","v64","v156","v1130","ix")])
multilevel::cronbach(scale(fff[,c("v64","v156","v1130")]))
psych::alpha(scale(fff[,c("v64","v156","v1130")]))
a<-princomp(scale(fff[,c("v64","v156","v1130")]))
(a$sdev^2)/sum(a$sdev^2)
gSimpStat(sccsA[,rev(iv4p)[1:23]])

xi<-"pdens"
fff[,paste(xi,2,sep=".")]<-fff[,xi]^2
fff[,paste(xi,3,sep=".")]<-fff[,xi]^3

putt<-c(putt,"pdens")
gSimpStat(fff[,putt])
putt<-c(paste(putt,2,sep="."),paste(putt,3,sep="."))
gSimpStat(fff[,putt])


#--make interaction terms---
sddv<-paste("v",814:819,sep="")
for (kk in sddv){
  fff[,paste(kk,"pdens",sep="")]<-fff[,kk]*fff[,"pdens"]
}

length(which(is.na(match(indpv,names(fff)))))

gSimpStat(fff[,sddv])
dim(fff)
names(fff)


#--geographical distance weight matrix--
dm<-as.matrix(sccsA[,c("long","lat")]) #society coordinates
dm<-distm(dm)                          #distance matrix--distance in meters
diag(dm)<-10^20                        #put very large number on diagonal
dm<-dm^-2                              #convert distance to proximity
u<-t(apply(-dm,1,rank))                #for each row, find proximity ranks
dm[which(u>25)]<-0                     #set cells to zero, except 25 closest
table(diag(dm))                        #make sure diagonal cells equal zero
bdd<-dm/rowSums(dm)                    #row normalize
rownames(bdd)<-sccsA$ord               #society ID as row and column names
colnames(bdd)<-sccsA$ord


#--other proxmity matrices---

awm<-function(a){
print(table(diag(a)))
print(isSymmetric(a))
diag(a)<-0
a<-a/rowSums(a)
print(table(rowSums(a)))
rownames(a)<-sccsA$ord
colnames(a)<-sccsA$ord
return(a)
}

bll<-awm(as.matrix(read.dta("langwm.dta")[,-1]))
brr<-awm(as.matrix(read.dta("relewm.dta")[,-1]))


#--check to see that rows are properly aligned in the five datasets--
#--sum should equal 186---
sum((sccsA$ord==read.dta("langwm.dta")[,1])*1)
sum((sccsA$ord==read.dta("relewm.dta")[,1])*1)

mwm<-function(a){
a<-a[zdv,zdv]
diag(a)<-0
z<-which(rowSums(a)==0)
a[z,]<-1
a<-a/rowSums(a)
return(a)
}

dd<-mwm(bdd)
rr<-mwm(brr)
ll<-mwm(bll)

dim(dd)
sum(rownames(dd)==fff$.id[which(fff$.imp==1)])



#----------------------------------
#--find optimal weight matrix------
#----------------------------------

URm<-formula(paste(ii,"~Wy+",paste(indpv,collapse="+"),sep=""))
#URm<-formula(paste(ii,"~Wy+",paste(xvv,collapse="+"),sep=""))
tr2<-NULL
tmr2<-NULL
sc<-10
for (d in 0:sc){
for (l in 0:sc){
r<-sc-d-l
if (r>=0){
csm<-d/sc*dd+l/sc*ll+r/sc*rr
r2<-NULL
mr2<-NULL
for (i in 1:nimp){
m9<-fff[which(fff$.imp==i),]
y<-as.matrix(m9[,ii])
xx<-as.matrix(m9[,unique(c(indpv,othexog))])
cy<-as.matrix(csm)%*%y
xdy<-as.matrix(csm)%*%xx
Wy<-fitted(lm(cy~xdy))
r2<-rbind(r2,cor(Wy,m9[,ii])^2)
mr2<-rbind(mr2,summary(lm(URm,data=m9))$r.squared)
}
tr2<-rbind(tr2,cbind(d,l,r,mean(r2)))
tmr2<-rbind(tmr2,cbind(d,l,r,mean(mr2)))
}
}
}

tmr2<-data.frame(tmr2[order(-tmr2[,4]),])
names(tmr2)<-c("d","l","r","ord")
tmr2[,4]<-(1:NROW(tmr2))

tr2<-data.frame(tr2[order(-tr2[,4]),])
colnames(tr2)<-c("d","l","r","ord")
tr2[,4]<-(1:NROW(tr2))
apply(tr2[1:5,],2,mean)/sc

pp<-rbind(tr2,tmr2)
wtwts<-as.matrix(apply(pp[which(pp[,"ord"]<=5),c("d","l","r")],2,mean)/sc)
wtwts

wmatll<-mat2listw(as.matrix(ll))  #--language is only one we need test--


#-----------------------------------------------------
#---Estimate model on each imputed dataset------------
#-----------------------------------------------------

#--independent variables, unrestricted model--
indvbs<-unique(indpv,xvv)

#--UNrestricted model--
amod<-formula(paste(ii,"~Wy+",paste(indvbs,collapse="+"),sep=""))
#--restricted model--
bmod<-formula(paste(ii,"~Wy+",paste(xvv,collapse="+"),sep=""))


#--will append values to these empty objects--
Uvif<-NULL
Uss<-NULL
Ubeta<-NULL
vif<-NULL
ss<-NULL
beta<-NULL
dng<-NULL
addit<-NULL
zkn<-NULL
Zsd<-NULL
UZsd<-NULL
tom<-NULL
hrz<-NULL
Jss2<-NULL
Jbeta2<-NULL


#--loop through the imputed datasets--
for (i in 1:nimp){

z<-which(fff$.imp==i)

#--Composite spatially lagged varb.--
cld<-wtwts[1]*dd+wtwts[2]*ll+wtwts[3]*rr
y<-as.matrix(fff[z,ii])
xx<-as.matrix(fff[z,indvbs])
xcy<-cld%*%xx   
cyc<-cld%*%y
o<-lm(cyc~xcy)
Wy<-fitted(o)
Xr2<-summary(o)$r.squared
fff[z,"Wy"]<-Wy

m9<-fff[z,]

#--Stage 2 OLS estimate of unrestricted model--

xUR<-lm(amod,data=m9)
coefxUR<-names(coef(xUR))[-1]
sdj<-coef(xUR)[coefxUR]*(apply(m9[,coefxUR],2,sd)/sd(m9[,ii]))
UZsd<-rbind(UZsd,sdj)

#--Stage 2 OLS estimate of restricted model--
xR<-lm(bmod,data=m9)
b1<-coef(xR)
coefxR<-names(b1)[-1]
sdj<-b1[coefxR]*(apply(m9[,coefxR],2,sd)/sd(m9[,ii]))
Zsd<-rbind(Zsd,sdj)

#--relaimpo-- #VERY time-consuming, uncomment ONLY on final run
om<-1
#om<-calc.relimp(xR)$lmg
tom<-rbind(tom,om)

#--test for adding additional variable--
addform<-formula(paste("~",paste(unique(c(indvbs,putt)),collapse="+"),"+.",sep=""))
o<-add1(xR,addform,test="F")[-1,]
addit<-c(addit,rownames(o[which(as.numeric(o$"Pr(F)")<=.1),]))

#--dfbetas and dfitts--------
hr<-cbind(data.frame(dfbetas(xR)),m9$.id)
hr[,1]<-data.frame(dffits(xR))
names(hr)[c(1,NCOL(hr))]<-c("dffits","society")
hrz<-rbind(hrz,hr)

p<-matrix(0,1,length(coefxUR))
z<-match(coefxR,coefxUR)
p[z]<-1
dropt<-coefxUR[which(p==0)]

#--corrected sigma2 and R2 for 2SLS--
qxx<-m9
qxx[,"Wy"]<-cyc
incpt<-matrix(1,NROW(qxx),1)
b<-coef(xR)
x<-as.matrix(cbind(incpt,qxx[,names(b)[-1]]))
e<-y-x%*%as.matrix(b)
cs2<-as.numeric(t(e)%*%e/(NROW(x)-NCOL(x)))
cr2<-as.numeric(1-t(e)%*%e/sum((y-mean(y))^2))

b<-coef(xUR)
x<-as.matrix(cbind(incpt,qxx[,names(b)[-1]]))
e<-y-x%*%as.matrix(b)
Ucs2<-as.numeric(t(e)%*%e/(NROW(x)-NCOL(x)))
Ucr2<-as.numeric(1-t(e)%*%e/sum((y-mean(y))^2))

#--collect coefficients and their variances--
ov<-summary(xR)
vif<-rbind(vif,vif(xR))
ss<-rbind(ss,diag(ov$cov*cs2))
#--collect robust coef. variances when there is heteroskedasticity--
#eb<-e^2
#x<-as.matrix(cbind(incpt,m9[,names(b)[-1]]))
#hcm<-inv(t(x)%*%x)%*%t(x)%*%diag(eb[1:length(eb)])%*%x%*%inv(t(x)%*%x)
#ss<-rbind(ss,diag(hcm))
beta<-rbind(beta,coef(xR))

ov<-summary(xUR)
Uvif<-rbind(Uvif,vif(xUR))
Uss<-rbind(Uss,diag(ov$cov*Ucs2))
Ubeta<-rbind(Ubeta,coef(xUR))


#--Hausman test: Restricted model--
coefR<-names(coef(xR))[-1]
ivex<-as.matrix(m9[,c(coefR,othexog)])
jjb<-formula(paste(as.character(bmod)[2],"~",as.character(bmod)[3],"+Exog"))
pxs<-data.frame(matrix(0,1,length(coefR)))
pxb<-data.frame(matrix(0,1,length(coefR)))
for (ia in 1:length(coefR)){
Exog<-residuals(lm(m9[,coefR[ia]]~ivex[,-ia]))
hxx<-lm(jjb,data=m9)
bz<-coef(hxx)
sz<-diag(summary(hxx)$cov*summary(hxx)$sigma^2)
pxs[ia]<-sz[length(sz)]
names(pxs)[ia]<-paste("Hausman test. H0: ",coefR[ia]," exogenous",sep="")
pxb[ia]<-bz[length(bz)]
names(pxb)[ia]<-paste("Hausman test. H0: ",coefR[ia]," exogenous",sep="")
}
Jss2<-rbind(Jss2,pxs)
Jbeta2<-rbind(Jbeta2,pxb)


#--collect some model diagnostics--
#--Ramsey RESET test--
p1<-qchisq(resettest(xR,type="fitted")$"p.value",1,lower.tail=FALSE)
#--Wald test (H0: dropped variables have coefficient equal zero)--
o<-linearHypothesis(xUR,dropt,test="Chisq")$"Pr(>Chisq)"[2]
p2<-qchisq(o,1,lower.tail=FALSE) #find Chisq with 1 d.f. and same pvalue
#--Heteroskedasticity test (H0: homoskedastic residuals)--
p3<-ncvTest(xR)$ChiSquare
#--Shapiro-Wilke normality test (H0: residuals normal)
p4<-qchisq(shapiro.test(e)$p.value,1,lower.tail=FALSE)
#--LaGrange Multiplier test for spatial autocorrelation: language--
o<-lm.LMtests(xR, wmatll, test=c("LMlag"))
p5<-as.numeric(o$LMlag$statistic)
#--model R2--
p7<-cr2
dng<-rbind(dng,cbind(p1,p2,p3,p4,p5,p7,Xr2,Ucr2))

}


#---------------------------------------------
#--Use Rubin's formulas to combine estimates--
#---------------------------------------------

#--UR model coefs. and p-values--
mnb<-apply(Ubeta,2,mean)
vrb<-colSums((Ubeta-t(matrix(mnb,length(mnb),nimp)))^2)/(nimp-1)
mnv<-apply(Uss,2,mean)
vrT<-mnv+vrb*(1-nimp^(-1))
fst<-mnb^2/vrT
r<-(1+nimp^(-1))*vrb/mnv
v<-round((nimp-1)*(1+r^(-1))^2)
pval<-pf(fst,1,v,lower.tail=FALSE)
Ubb<-data.frame(round(cbind(mnb,fst,v,pval),3))
Ubb$VIF[2:NROW(Ubb)]<-round(apply(Uvif,2,mean),3)
names(Ubb)<-c("coef","Fstat","ddf","pvalue","VIF")
Ubb$stdcoef[2:NROW(Ubb)]<-round(apply(UZsd,2,mean),3)
Ubb$coef<-round(mnb,12)

ix<-factor(Ubb$pvalue,levels=c("   ","*  ","** ","***"))
px<-Ubb$pvalue
z<-which(px>=.1)
ix[z]<-"   "
z<-which(px<.10)
ix[z]<-"*  "
z<-which(px<.05)
ix[z]<-"** "
z<-which(px<.01)
ix[z]<-"***"
Ubb$stars<-as.character(ix)

#--find final regr. coefs. and p-values--
mnb<-apply(beta,2,mean)
vrb<-colSums((beta-t(matrix(mnb,length(mnb),nimp)))^2)/(nimp-1)
mnv<-apply(ss,2,mean)
vrT<-mnv+vrb*(1-nimp^(-1))
fst<-mnb^2/vrT
r<-(1+nimp^(-1))*vrb/mnv
v<-round((nimp-1)*(1+r^(-1))^2)
pval<-pf(fst,1,v,lower.tail=FALSE)
bbb<-data.frame(round(cbind(mnb,fst,v,pval),3))
bbb$VIF[2:NROW(bbb)]<-round(apply(vif,2,mean),3)
names(bbb)<-c("coef","Fstat","ddf","pvalue","VIF")
bbb$stdcoef[2:NROW(bbb)]<-round(apply(Zsd,2,mean),3)
bbb$relimp[2:NROW(bbb)]<-round(apply(tom,2,mean),3)
bbb$coef<-round(mnb,12)

ix<-factor(bbb$pvalue,levels=c("   ","*  ","** ","***"))
px<-bbb$pvalue
z<-which(px>=.1)
ix[z]<-"   "
z<-which(px<.10)
ix[z]<-"*  "
z<-which(px<.05)
ix[z]<-"** "
z<-which(px<.01)
ix[z]<-"***"
bbb$stars<-as.character(ix)


#--Then combine the diagnostics we collected--
dng<-data.frame(dng)
names(dng)<-c("RESET test. H0: model has correct functional form",
"Wald test. H0: appropriate variables dropped",
"Breusch-Pagan test. H0: residuals homoskedastic",
"Shapiro-Wilkes test. H0: residuals normal",
"LM test. H0: Spatial lag (language) not needed",
"R2:final model","R2:IV(composite)","R2:UR model")
r2<-apply(dng[,6:8],2,mean)
adng<-dng[,1:5]
mdm<-apply(adng,2,mean)
vrd<-colSums((adng-t(matrix(mdm,length(mdm),nimp)))^2)/(nimp-1)
aa<-4*mdm^2-2*vrd
aa[which(aa<0)]<-0
rd<-(1+nimp^(-1))*vrd/(2*mdm+aa^.5)
vd<-(nimp-1)*(1+rd^(-1))^2
Dm<-(mdm-(nimp-1)/(nimp+1)*rd)/(1+rd)
#-All chi-sq we collected have df=1-------
pvald<-pf(Dm,1,vd,lower.tail=FALSE)
ccc<-data.frame(round(cbind(Dm,vd,pvald),3))
names(ccc)<-c("Fstat","df","pvalue")

ix<-factor(ccc$pvalue,levels=c("   ","*  ","** ","***"))
px<-ccc$pvalue
z<-which(px>=.1)
ix[z]<-"   "
z<-which(px<.10)
ix[z]<-"*  "
z<-which(px<.05)
ix[z]<-"** "
z<-which(px<.01)
ix[z]<-"***"
ccc$stars<-as.character(ix)
 
#--adjust relimp to R2 for 2SLS--
xz<-bbb$relimp[2:NROW(bbb)]
wt<-r2[1]/sum(xz)
bbb$relimp[2:NROW(bbb)]<-xz*wt


#--Hausman tests for endogeneity--
mnb<-apply(Jbeta2,2,mean)
vrb<-colSums((Jbeta2-t(matrix(mnb,length(mnb),nimp)))^2)/(nimp-1)
mnv<-apply(Jss2,2,mean)
vrT<-mnv+vrb*(1-nimp^(-1))
fst<-mnb^2/vrT
r<-(1+nimp^(-1))*vrb/mnv
v<-round((nimp-1)*(1+r^(-1))^2)
pval<-pf(fst,1,v,lower.tail=FALSE)
haus<-data.frame(round(cbind(fst,v,pval),3))
names(haus)<-c("Fstat","df","pvalue")

ix<-factor(haus$pvalue,levels=c("   ","*  ","** ","***"))
px<-haus$pvalue
z<-which(px>=.1)
ix[z]<-"   "
z<-which(px<.10)
ix[z]<-"*  "
z<-which(px<.05)
ix[z]<-"** "
z<-which(px<.01)
ix[z]<-"***"
haus$stars<-as.character(ix)

ccc<-rbind(ccc,haus)

r1<-rownames(Ubb)
k<-match(rownames(Ubb),uxx$varb)
Ubb<-cbind(r1,uxx[k,"label"],Ubb)
names(Ubb)[2]<-"label"
rownames(Ubb)<-r1

r1<-rownames(bbb)
k<-match(rownames(bbb),uxx$varb)
bbb<-cbind(r1,uxx[k,4],bbb)
rownames(bbb)<-r1

Ubb
bbb
ccc
wtwts
r2
a<-table(addit)
a[order(a)]

#--dfbetas--

ppn<-names(hrz)[-NCOL(hrz)]
o<-aggregate(hrz[,ppn],list(hrz$society),mean)
o$ord<-as.numeric(as.character(o$Group.1))
o<-o[order(o$ord),-1]
k<-match(o$ord,sccsA$ord)
o[,"socname"]<-sccsA$socname[k]
rf<-o[,c("ord","socname")]

co<-as.matrix(o[,ppn[-1]])
z<-which(abs(co)>2/NROW(m9)^.5,arr.ind=TRUE)
ths<-round((co[z])/(2/NROW(m9)^.5),2)

g<-round(aggregate(fff[,c(ii,ppn[-1])],list(fff$.id),mean),4)
names(g)[1]<-"ord"
sum(g$ord==o$ord)
cg<-as.matrix(g[,ppn[-1]])

f<-cbind(data.frame(o$socname[z[,1]]),(ppn[-1])[z[,2]],
round(co[z],4),ths,round(cg[z],4),g[z[,1],ii])
names(f)<-c("socname","varb","dfBeta","ratio2C","varbVal","depVal")
f$coef<-round(bbb[as.character(f$varb),"coef"],5)
f<-f[order(f$varb,f$ratio2C),]

#---------------------------------
#---Tables------------------------
#---------------------------------
load("ttSPSSplus.Rdata",.GlobalEnv)

#--Tables 1 and 2---------
ix<-c(ii,indpv)[which(!is.na(match(c(ii,indpv),names(sccsA))))]
aa<-gSimpStat(sccsA[,ix])
aa<-cbind(uxx[ix,3:4],aa)
Atf(aa,"z",FALSE)

k<-which(sapply(fff,function(x) class(x))=="factor")
ktt<-k[which(is.na(match(names(k),names(tt))))]
for (ix in names(ktt)){
Atf(table(sccsA[,ix],useNA="ifany"),"z",TRUE)
}
ktt<-k[which(!is.na(match(names(k),names(tt))))]
for (ix in names(ktt)){
Atf(table(tt[,ix],useNA="ifany"),"z",TRUE)
}


g<-aggregate(fff[,c(ii,indpv)],list(fff$.id),mean)
g<-gSimpStat(g[,c(ii,indpv)])
Atf(g,"z",TRUE)

#--UR and R models, diagnostics, R2, wts, dfbetas---
Atf(Ubb,stm,FALSE)
Atf(bbb,stm,TRUE)
Atf(r2,stm,TRUE)
Atf(wtwts,stm,TRUE)
Atf(ccc,stm,TRUE)
Atf(f,stm,TRUE)


#--cf Nolan's categories with those in SCCS----

metal<-(sccsA$v248<9)*1
weave<-(sccsA$v249<9)*1
plow<-(sccsA$v243>1)*1
horse<-(sccsA$v244==4)*1

nx<-c("HuntGath","fish","anim","agri")
avv<-paste("v",c(203:207),sep="")
hx<-sccsA[,avv]
hx[,1]<-apply(hx[,1:2],1,sum)
hx<-as.matrix(hx[,-2])
colnames(hx)<-nx
rownames(hx)<-sccsA$socname
head(hx)
ft<-(hx==apply(hx,1,max))*(hx>=4) #max must be >=4
ft<-ft*(rowSums(ft)==1) # no ties

#--as presented in book---
clsf<-as.character(rep("other",NROW(sccsA)))
z<-which(ft>0,arr.ind=TRUE)
clsf[z[,1]]<-nx[z[,2]]
z<-which(clsf=="HuntGath" & horse==1)
clsf[z]<-"other"
z<-which(clsf=="agri" & plow==0 & metal==0)
clsf[z]<-"simpHort"
z<-which(clsf=="agri" & plow==0 & metal==1)
clsf[z]<-"advcHort"
z<-which(clsf=="agri" & plow==1 & metal==1)
clsf[z]<-"agrarian"
z<-which(clsf=="agri")
clsf[z]<-"other"

Atf(table(tt$v858,clsf),stm,TRUE)

#---------------------------------
#---Figures-----------------------
#---------------------------------

wdxx<-5


#--Map----
load("world_countries_24.rda",.GlobalEnv)

png(file="map.png",width=8,height=5,units="in",pointsize=10,res=600)

lgt<-sccsA[,ii]
splgt<-SpatialPointsDataFrame(coordinates(sccsA[,c("long","lat")]),data.frame(lgt))
splgt<-splgt[order(-splgt@data$lgt),]
tmx<-which(is.na(splgt@data$lgt))
nmx<-which(!is.na(splgt@data$lgt))
brks<-quantile(splgt@data$lgt,seq(0,1,.1),na.rm=TRUE)
cols <- colorRampPalette(c("yellow", "darkred"))(length(brks))

plot(world_countries,col="black")            
plot(splgt[nmx,],pch=21,add=TRUE,cex=(splgt@data$lgt[nmx]/2)^.5,
col=cols[findInterval(splgt@data$lgt[nmx], brks, all.inside=TRUE)],
bg=cols[findInterval(splgt@data$lgt[nmx], brks, all.inside=TRUE)])
plot(splgt[tmx,],pch=4,add=TRUE,col="cyan")
plot(splgt[tmx,],pch=1,cex=1.5,add=TRUE,col="cyan")
mtext("Frequency of External War (v1650)",line=-2, side=1,cex=.7)

dev.off()


#--population density---

g<-aggregate(fff[,c(ii,indpv,"plow")],list(fff$.id),mean)
rapp<-paste("v",814:819,sep="")
table(rowSums(sccsA[,rapp])) #problem in original data?--should sum to 100
z<-which(rowSums(sccsA[,rapp])!=100)
sccsA[z,c("socname",rapp)]
rowSums(sccsA[,rapp])[z]

k<-match(fff$.id,idata$.id)
oxg<-aggregate(idata[k,rapp],list(idata$.id[k]),mean)
oxg<-oxg[,rapp]
o<-(oxg==apply(oxg,1,max))*1 
rappn<-c("Agriculture","Domestic Animals","Fishing","Hunting","Gathering","Trade")

table(rowSums(oxg))
zax<-which(rowSums(oxg)<=100) #--remove the three outliers for a better chart
gx<-g[zax,]
ox<-o[zax,]
dim(ox)

ap<-bbb["pdens","coef"]
ax<-matrix(bbb[paste(rapp,"pdens",sep=""),"coef"],NROW(gx),length(rapp),byrow=TRUE)
jj<-matrix(ap+apply(ax*gx[,rapp],1,sum),NROW(gx),1)

fv<-paste(paste(paste(round(bbb[paste(rapp,"pdens",sep=""),"coef"],4),"*",rapp,sep=""),sep=""),collapse="")
fv<-paste("effect=(",round(ap,4),fv,")*pdens",sep="")
fv
Atf(fv,stm,TRUE)

png(file="pdens.png",width=wdxx,height=6.5,units="in",pointsize=10,res=600)
layout(matrix(1:2,2,1))

plot(gx[,"pdens"],jj,cex=0,ylim=c(min(jj),.1),
main=paste("Marginal Effect of Pop. Density on Freq. Ext. War",sep=""),
ylab="Marginal Effect on Freq. Ext. War",xlab="Population density (pdens)")
abline(h=0,v=0,col="blue",lty=3)
abline(lm(jj~gx[,"pdens"]), col="red")
for (ig in 1:length(rapp)){
k<-which(ox[,ig]==1)
points(gx[k,"pdens"],jj[k],pch=ig,cex=1,col=ig)
}
round(summary(lm(jj~gx[,"pdens"]))$r.squared,3)
text(0.3,-0.2,expression(paste(R^2,"=0.045")),cex=.9)
#legend(1,1,rappn,pch=1:length(rapp),col=1:length(rapp),cex=.8)

plot(gx[,"pdens"],jj*gx[,"pdens"],cex=0,ylim=c(-1,1),
main=paste("Effect of Pop. Density on Freq. Ext. War",sep=""),
xlab="Population density (pdens)",ylab="Effect on Freq. Ext. War")
abline(lm(jj*gx[,"pdens"]~gx[,"pdens"]), col="red")
abline(h=0,v=0,col="blue",lty=3)
for (ig in 1:length(rapp)){
k<-which(ox[,ig]==1)
points(gx[k,"pdens"],jj[k]*gx[k,"pdens"],pch=ig,cex=1,col=ig)
}
round(summary(lm(jj*gx[,"pdens"]~gx[,"pdens"]))$r.squared,3)
text(0.3,0.2,expression(paste(R^2,"=0.796")),cex=.9)
legend(.75,1,rappn,pch=1:length(rapp),col=1:length(rapp),cex=.8)


layout(1)
dev.off()




#---aggriculture v814 ---

axp<-bbb["v814pdens","coef"]
ax1<-bbb["v814","coef"]
ax2<-bbb["v814.2","coef"]

frml<-expression(hat(alpha)["v814"]*v814[i]+hat(alpha)["v814.2"]*v814[i]^2+hat(alpha)["v814pdens"]*v814[i]*pdens[i])
frml<-expression(hat(alpha)["x"]*x[i]+hat(alpha)["x2"]*x[i]^2+hat(alpha)["x.p"]*x[i]*p[i])

fv<-paste(round(c(axp,ax1,ax2),4),"*v814",sep="")
fv<-paste(paste(fv,c("*pdens","","^2"),sep=""),collapse=" + ")
fv<-paste("effect= ",fv,sep="")
fv
Atf(fv,stm,TRUE)



k<-match(fff$.id,idata$.id)
oxg<-aggregate(idata[k,rapp],list(idata$.id[k]),mean)
oxg<-oxg[,rapp]
ox<-(oxg==apply(oxg,1,max))*1
head(oxg)
dim(oxg);dim(g)


#-------Version with rings and plow+metal symbols-------

g$xx<-1
g$xx[which(ox[,"v814"]==1)]<-2
g$xx[which(g$metal>.5 & ox[,"v814"]==1)]<-3
g$xx[which(g$plow>.5 & g$metal>.5 & ox[,"v814"]==1)]<-4
ruff<-c("nonAgricult","agriculture","agric+metal","plow+metal")

png(file="v814c.png",width=wdxx,height=6.5,units="in",pointsize=10,res=600)

layout(matrix(1:3,3,1,byrow=TRUE))

dyd814<-axp*g[,"pdens"]+ax1+2*ax2*g[,"v814"]
plot(g[,"v814"],dyd814,cex=(2+g[,"pdens"]),
main="Marginal Effect of importance of agriculture on Freq. Ext. War",
xlab="Importance of agriculture (v814)",ylab="Marginal Effect on Freq. Ext. War")
lines(lowess(g[,"v814"],dyd814),lty=2,col="red")
abline(h=0,v=0,col="blue",lty=3)

y814<-(axp*g[,"pdens"]+ax1)*g[,"v814"]+ax2*g[,"v814"]^2
plot(g[,"v814"],y814,cex=(2+g[,"pdens"]),
main="Effect of importance of agriculture on Freq. Ext. War",
xlab="Importance of agriculture (v814)",ylab="Effect on Freq. Ext. War")
lines(lowess(g[,"v814"],y814),lty=2,col="red")
abline(h=0,v=0,col="blue",lty=3)

y814<-(axp*g[,"pdens"]+ax1)*g[,"v814"]+ax2*g[,"v814"]^2
plot(g[,"v814"],y814,cex=0,
main="Effect of importance of agriculture on Freq. Ext. War",
xlim=c(min(g[,"v814"]),2.6),
xlab="Importance of agriculture (v814)",ylab="Effect on Freq. Ext. War")
lines(lowess(g[,"v814"],y814),lty=2,col="red")
abline(h=0,v=0,col="blue",lty=3)
for (ig in unique(g$xx)){
k<-which(g[,"xx"]==ig)
points(g[k,"v814"],y814[k],pch=ig,cex=1,col=ig)
} 
legend(2,1,ruff,pch=1:length(ruff),col=1:length(ruff),cex=1)

layout(1)

dev.off()




#---v814-v819 ---

ocf<-bbb[paste(rapp,"pdens",sep=""),"coef"]
vbs<-matrix(ocf[-1],NROW(g),length(rapp[-1]),byrow=TRUE)
xhh<-g[,rapp[-1]]*g[,"pdens"]*vbs
mxhh<-g[,"pdens"]*vbs

axp<-bbb["v814pdens","coef"]
ax1<-bbb["v814","coef"]
ax2<-bbb["v814.2","coef"]
y814<-(axp*g[,"pdens"]+ax1)*g[,"v814"]+ax2*g[,"v814"]^2
dyd814<-axp*g[,"pdens"]+ax1+2*ax2*g[,"v814"]
xhh<-cbind(y814,xhh)
mxhh<-cbind(dyd814,mxhh)
names(xhh)<-rapp
names(mxhh)<-rapp

ya<-range(xhh)
mya<-range(mxhh)

fv<-paste(paste(round(c(axp,ax1,ax2),4),c("*pdens","","*2*v814"),sep=""),collapse=" + ")
fv<-paste("dy/dv814=",fv)
for (ig in 2:6){
fv<-c(fv,paste("dy/d",rapp[ig],"= ",round(ocf[ig],4),"*pdens",sep=""))
}

tv<-paste(paste(round(c(axp,ax1,ax2),4),c("*pdens*v814","*v814","*v814^2"),sep=""),collapse=" + ")
tv<-paste("effect of v814= ",tv)
for (ig in 2:6){
tv<-c(tv,paste("effect of ",rapp[ig],"= ",round(ocf[ig],4),"*pdens*",rapp[ig],sep=""))
}

vft<-paste(tv," ==> ",fv,"",sep="")
Atf(vft,stm,TRUE)

png(file="v814v819.png",width=wdxx,height=6.5,units="in",pointsize=10,res=600)

layout(matrix(1:12,4,3),width=c(3,2.2,2.2))
for (ig in 1:6){

if (ig<=2){

par(mar=c(0, 4, 2, 0) + 0.1)
plot(g[,rapp[ig]],mxhh[,ig],cex=(2+g[,"pdens"]),ylim=mya,xaxt="n",
ylab="Marginal Effect")
lines(lowess(g[,rapp[ig]],mxhh[,ig]),lty=2,col="red")
abline(h=0,v=0,col="blue",lty=3)
text(1,7,paste("tau=",round(cor(g[,rapp[ig]],mxhh[,ig],method="kendall"),3),sep=""),cex=.9)

par(mar=c(5, 4, 0, 0) + 0.1)
plot(g[,rapp[ig]],xhh[,ig],cex=(2+g[,"pdens"]),ylim=ya,
xlab=paste(rappn[ig]," (",rapp[ig],")",sep=""),ylab="Effect")
lines(lowess(g[,rapp[ig]],xhh[,ig]),lty=2,col="red")
abline(h=0,v=0,col="blue",lty=3)
text(1,10,paste("tau=",round(cor(g[,rapp[ig]],xhh[,ig],method="kendall"),3),sep=""),cex=.9)
}

if (ig>2){

par(mar=c(0, 0, 2, 0) + 0.1)
plot(g[,rapp[ig]],mxhh[,ig],cex=(2+g[,"pdens"]),ylim=mya,xaxt="n",yaxt="n")
lines(lowess(g[,rapp[ig]],mxhh[,ig]),lty=2,col="red")
abline(h=0,v=0,col="blue",lty=3)
text(1,7,paste("tau=",round(cor(g[,rapp[ig]],mxhh[,ig],method="kendall"),3),sep=""),cex=.9)

par(mar=c(5, 0, 0, 0) + 0.1)
plot(g[,rapp[ig]],xhh[,ig],cex=(2+g[,"pdens"]),ylim=ya,
xlab=paste(rappn[ig]," (",rapp[ig],")",sep=""),yaxt="n")
lines(lowess(g[,rapp[ig]],xhh[,ig]),lty=2,col="red")
abline(h=0,v=0,col="blue",lty=3)
text(1,10,paste("tau=",round(cor(g[,rapp[ig]],xhh[,ig],method="kendall"),3),sep=""),cex=.9)
}

par(mar=c(5, 4, 4, 2) + 0.1)
}

layout(1)

dev.off()




#---v81---

png(file="v81.png",width=5,height=6.5,units="in",pointsize=10,res=600)

scy<-1.2
sc<-2.2
pfs<-.75

a1<-bbb["v81","coef"]
a3<-bbb["v81.3","coef"]

fv<-paste(round(c(a1,a3),4),"*v81",sep="")
fv<-paste(paste(fv,c("","^3"),sep=""),collapse=" + ")
fv<-paste("effect= ",fv,sep="")
fv
Atf(fv,stm,TRUE)

layout(matrix(1:2,2,1))

y81<-a1*g[,"v81"]+a3*g[,"v81"]^3
dyd81<-a1+3*a3*g[,"v81"]^2

o<-data.frame(table(g[,"v81"],dyd81))
o<-o[which(o$Freq>0),]
o<-o[order(o[,1]),]
k<-which(sapply(o,function(x) class(x))=="factor")
o[,k]<-sapply(o[,k],function(x) as.numeric(as.character(x)))
ph<-cbind(aggregate(o,list(round(o[,1],1)),mean),as.character(levels(tt[,"v81"])))
ph<-ph[,c(1,2,3,5)]
curve(a1+3*a3*x^2,min(g[,"v81"]),max(g[,"v81"]),xlim=range(g[,"v81"])*sc,
ylim=range(dyd81)*scy,
main="Marginal Effect of v81 on Freq. Ext. War",
xlab=paste(Ubb["v81","label"],"(v81)"),ylab="Marginal Effect on Freq. Ext. War",cex.lab=pfs*1.3)
text(ph[,1],ph[,3]*1.1,ph[,4],cex=pfs)
points(ph[,1],ph[,3],pch=4,cex=1,col="red")
abline(h=0,col="blue",lty=3)

o<-data.frame(table(g[,"v81"],y81))
o<-o[which(o$Freq>0),]
o<-o[order(o[,1]),]
k<-which(sapply(o,function(x) class(x))=="factor")
o[,k]<-sapply(o[,k],function(x) as.numeric(as.character(x)))
ph<-cbind(aggregate(o,list(round(o[,1],1)),mean),as.character(levels(tt[,"v81"])))
ph<-ph[,c(1,2,3,5)]
curve(a1*x+a3*x^3,min(g[,"v81"]),max(g[,"v81"]),xlim=range(g[,"v81"])*sc,
ylim=range(y81)*scy,
main="Effect of v81 on Freq. Ext. War",
xlab=paste(Ubb["v81","label"],"(v81)"),ylab="Effect on Freq. Ext. War",cex.lab=pfs*1.3)
text(ph[,1],ph[,3]*1.1,ph[,4],cex=pfs)
points(ph[,1],ph[,3],pch=4,cex=1,col="red")
abline(h=0,col="blue",lty=3)

layout(1)

dev.off()


#---v236---

png(file="v236.png",width=5,height=6.5,units="in",pointsize=10,res=600)

a1<-bbb["v236","coef"]
a2<-bbb["v236.2","coef"]

fv<-paste(round(c(a1,a2),4),"*v236",sep="")
fv<-paste(paste(fv,c("","^2"),sep=""),collapse=" + ")
fv<-paste("effect= ",fv,sep="")
fv
Atf(fv,stm,TRUE)

layout(matrix(1:2,2,1))

dyd236<-a1+2*a2*g[,"v236"]
o<-data.frame(table(g[,"v236"],dyd236))
o<-o[which(o$Freq>0),]
o<-o[order(o[,1]),]
k<-which(sapply(o,function(x) class(x))=="factor")
o[,k]<-sapply(o[,k],function(x) as.numeric(as.character(x)))
ph<-cbind(aggregate(o,list(round(o[,1],1)),mean),as.character(levels(tt[,"v236"])))
ph<-ph[,c(1,2,3,5)]
curve(a1+2*a2*x,min(g[,"v236"]),max(g[,"v236"]),xlim=range(g[,"v236"])*sc,
main="Marginal Effect of v236 on Freq. Ext. War",
ylim=range(dyd236)+c(-.1,.1),
xlab=paste(Ubb["v236","label"],"(v236)"),ylab="Marginal Effect on Freq. Ext. War",cex.lab=pfs*1.3)
text(ph[,1],ph[,3]*1.1,ph[,4],cex=pfs)
points(ph[,1],ph[,3],pch=4,cex=1,col="red")
abline(h=0,col="blue",lty=3)

y236<-a1*g[,"v236"]+a2*g[,"v236"]^2
o<-data.frame(table(g[,"v236"],y236))
o<-o[which(o$Freq>0),]
o<-o[order(o[,1]),]
k<-which(sapply(o,function(x) class(x))=="factor")
o[,k]<-sapply(o[,k],function(x) as.numeric(as.character(x)))
ph<-cbind(aggregate(o,list(round(o[,1],1)),mean),as.character(levels(tt[,"v236"])))
ph<-ph[,c(1,2,3,5)]
curve(a1*x+a2*x^2,min(g[,"v236"]),max(g[,"v236"]),xlim=range(g[,"v236"])*sc,
main="Effect of v236 on Freq. Ext. War",
ylim=range(y236)+c(-.1,.1),
xlab=paste(Ubb["v236","label"],"(v236)"),ylab="Effect on Freq. Ext. War",cex.lab=pfs*1.3)
text(ph[,1],ph[,3]*1.1,ph[,4],cex=pfs)
points(ph[,1],ph[,3],pch=4,cex=1,col="red")
abline(h=0,col="blue",lty=3)


layout(1)

dev.off()



#---WWF map----
#--large data file, may not open successfully on all systems--

load(url("http://dl.dropbox.com/u/9256203/wwfMHT.Rdata"),.GlobalEnv)
ID<-getSpPPolygonsIDSlots(wwfMHT)
negs<-which(ID=="Boreal forest/taigas" | ID=="Temperate coniferous forests")
poss<-which(ID=="Temperate broadleaf and mixed forests")
avgs<-which(is.na(match(ID,ID[c(negs,poss)])))

png(file="wwfMHTmap.png",width=8,height=5,units="in",pointsize=10,res=600)

plot(wwfMHT,col="darkred",border="darkred")
plot(wwfMHT[poss,],col="black",border="black",add=TRUE)
plot(wwfMHT[negs,],col="yellow",border="yellow",add=TRUE)
plot(wwfMHT[avgs,],col="darkred",border="darkred",add=TRUE)
plot(wwfMHT[negs,],col="yellow",border="yellow",add=TRUE)
legend(-180,-40,c("More frequent war","Average frequency war","Less frequent war"),
fill=c("black","darkred","yellow"))
mtext("Ecological habitats related to external war",line=-1, side=1,cex=1)

dev.off()





#---------------------------------------------------------
#---Appendix: sensitivity of pdens to omitted variables---
#---------------------------------------------------------





k<-match(fff$.id,idata$.id)
oxg<-aggregate(idata[k,rapp],list(idata$.id[k]),mean)
oxg<-oxg[,rapp]
ox2<-(oxg==apply(oxg,1,max))*1
rappn<-c("Agriculture","Domes.Anim","Fishing","Hunting","Gathering","Trade")

table(rowSums(oxg))
zax<-which(rowSums(oxg)<=100) #--remove the three outliers for a better chart


ivb<-rownames(bbb)[-1]
pvb<-ivb[agrep("pdens",ivb)]
mvb<-gsub("pdens","",pvb)
mvb[1]<-"ones"
m9$ones<-1
jvb<-ivb[which(is.na(match(ivb,pvb)))]

ox<-formula(paste("v1650~",paste(pvb,collapse="+"),sep=""))
o<-summary(lm(ox,data=m9))
dums<-as.matrix(m9[,pvb])
bet<-matrix(coef(o)[pvb,1],length(pvb),1)
score<-dums%*%bet
Atf(cor(score,m9$pdens),"tabs",FALSE) #--only population density in model--

pff<-NULL
for (ji in jvb){
o<-summary(lm(formula(paste("v1650~",paste(c(ji,pvb),collapse="+"),sep="")),data=m9))
dums<-as.matrix(m9[,pvb])
bet<-matrix(coef(o)[pvb,1],length(pvb),1)
match(rownames(bet),colnames(dums))
score<-dums%*%bet
pff<-rbind(pff,as.numeric(cor(score,m9$pdens)))
}
rownames(pff)<-jvb
pff<-cbind(pff[order(pff),])
Atf(pff,"tabs",TRUE)


png(file="Omitted1.png",width=6,height=7.2,units="in",pointsize=10,res=600)

layout(matrix(1:8,4,2,byrow=TRUE))


par(mar=c(4, 4, 3, 1) + 0.1)

o<-summary(lm(formula(paste("v1650~",paste(c(pvb),collapse="+"),sep="")),data=m9))
dums<-as.matrix(m9[,pvb])
bet<-matrix(coef(o)[pvb,1],length(pvb),1)
score<-dums%*%bet
plot(m9$pdens,score,xlab="pdens",ylab="fitted value",main="Only pdens terms",cex=0)
lines(lowess(m9$pdens,score,na.rm=TRUE),col="red")
text(quantile(m9$pdens,.95),quantile(score,.99),round(cor(m9$pdens,score),3))
for (ig in 1:length(rapp)){
k<-which(ox2[zax,ig]==1)
points(m9$pdens[zax[k]],score[zax[k]],pch=ig,cex=1,col=ig)
}

dums<-as.matrix(m9[,mvb])
score<-dums%*%bet
hist(score,breaks=30,xlim=c(-2.2,1.5),
#xlim=c(min(score),max(0,max(score))),
xlab="pdens",ylab="marginal effect of pdens",main="Only pdens terms")
abline(v=0,col="blue",lty=2)

o<-summary(lm(formula(paste("v1650~",paste(c("v93.CapitalistEnt",pvb),collapse="+"),sep="")),data=m9))
dums<-as.matrix(m9[,pvb])
bet<-matrix(coef(o)[pvb,1],length(pvb),1)
score<-dums%*%bet
plot(m9$pdens,score,xlab="pdens",ylab="fitted value",main="+v93.CapitalistEnt",cex=0)
lines(lowess(m9$pdens,score,na.rm=TRUE),col="red")
text(quantile(m9$pdens,.95),quantile(score,.99),round(cor(m9$pdens,score),3))
for (ig in 1:length(rapp)){
k<-which(ox2[zax,ig]==1)
points(m9$pdens[zax[k]],score[zax[k]],pch=ig,cex=1,col=ig)
}

dums<-as.matrix(m9[,mvb])
score<-dums%*%bet
hist(score,breaks=30,xlim=c(-2.2,1.5),
#,xlim=c(min(score),max(0,max(score))),
xlab="pdens",ylab="marginal effect of pdens",main="+v93.CapitalistEnt")
abline(v=0,col="blue",lty=2)

o<-summary(lm(formula(paste("v1650~",paste(c("metal",pvb),collapse="+"),sep="")),data=m9))
dums<-as.matrix(m9[,pvb])
bet<-matrix(coef(o)[pvb,1],length(pvb),1)
score<-dums%*%bet
plot(m9$pdens,score,xlab="pdens",ylab="fitted value",main="+metal",cex=0)
lines(lowess(m9$pdens,score,na.rm=TRUE),col="red")
text(quantile(m9$pdens,.95),quantile(score,.99),round(cor(m9$pdens,score),3))
for (ig in 1:length(rapp)){
k<-which(ox2[zax,ig]==1)
points(m9$pdens[zax[k]],score[zax[k]],pch=ig,cex=1,col=ig)
}

dums<-as.matrix(m9[,mvb])
score<-dums%*%bet
hist(score,breaks=30,xlim=c(-2.2,1.5),
#,xlim=c(min(score),max(0,max(score))),
xlab="pdens",ylab="marginal effect of pdens",main="+metal")
abline(v=0,col="blue",lty=2)

o<-summary(lm(formula(paste("v1650~",paste(ivb,collapse="+"),sep="")),data=m9))
dums<-as.matrix(m9[,pvb])
bet<-matrix(coef(o)[pvb,1],length(pvb),1)
score<-dums%*%bet
plot(m9$pdens,score,xlab="pdens",ylab="fitted value",main="full model",cex=0)
lines(lowess(m9$pdens,score,na.rm=TRUE),col="red")
text(quantile(m9$pdens,.95),quantile(score,.99),round(cor(m9$pdens,score),3))
for (ig in 1:length(rapp)){
k<-which(ox2[zax,ig]==1)
points(m9$pdens[zax[k]],score[zax[k]],pch=ig,cex=1,col=ig)
}

dums<-as.matrix(m9[,mvb])
score<-dums%*%bet
hist(score,breaks=30,xlim=c(-2.2,1.5),
#,xlim=c(min(score),max(0,max(score))),
xlab="pdens",ylab="marginal effect of pdens",main="full model")
abline(v=0,col="blue",lty=2)


par(mar=c(5, 4, 4, 2) + 0.1)
layout(1)

dev.off()





png(file="Omitted2.png",width=6,height=5,units="in",pointsize=10,res=600)

layout(matrix(1:3,1,3))

#--your model--
o<-summary(lm(v1650~pdens+factor(v858):pdens,data=m9)) 
o
mat<-model.matrix(~pdens+factor(v858):pdens,data=m9)
tbs<-rownames(coef(o)[-1,])
match(tbs,colnames(mat))
dums<-mat[,tbs]
bet<-as.matrix(coef(o)[tbs,1],length(tbs),1)
match(rownames(bet),colnames(dums))
score<-dums%*%bet
plot(m9$pdens,score,xlab="pdens",ylab="fitted value",main="Only pdens terms",cex=0)
lines(lowess(m9$pdens,score),col="red")
text(quantile(m9$pdens,.7),quantile(score,.99),paste("Pearson=",round(cor(m9$pdens,score),3)))
abline(h=0,col="blue",lty=2)
for (ig in 1:length(rapp)){
k<-which(ox2[zax,ig]==1)
points(m9$pdens[zax[k]],score[zax[k]],pch=ig,cex=1,col=ig)
}
Atf(cor(score,m9$pdens),"tabs",TRUE) #--only population density in model--

#--include metal--
o<-summary(lm(v1650~metal+pdens+factor(v858):pdens,data=m9)) 
o
bet<-as.matrix(coef(o)[tbs,1],length(tbs),1)
score<-dums%*%bet
plot(m9$pdens,score,xlab="pdens",ylab="fitted value",main="+metal",cex=0)
lines(lowess(m9$pdens,score),col="red")
text(quantile(m9$pdens,.7),quantile(score,.99),paste("Pearson=",round(cor(m9$pdens,score),3)))
abline(h=0,col="blue",lty=2)
for (ig in 1:length(rapp)){
k<-which(ox2[zax,ig]==1)
points(m9$pdens[zax[k]],score[zax[k]],pch=ig,cex=1,col=ig)
}

#--include v93.CapitalistEnt--
o<-summary(lm(v1650~v93.CapitalistEnt+pdens+factor(v858):pdens,data=m9)) 
o
bet<-as.matrix(coef(o)[tbs,1],length(tbs),1)
score<-dums%*%bet
plot(m9$pdens,score,xlab="pdens",ylab="fitted value",main="+v93.CapitalistEnt",cex=0)
lines(lowess(m9$pdens,score),col="red")
text(quantile(m9$pdens,.7),quantile(score,.99),paste("Pearson=",round(cor(m9$pdens,score),3)))
abline(h=0,col="blue",lty=2)
for (ig in 1:length(rapp)){
k<-which(ox2[zax,ig]==1)
points(m9$pdens[zax[k]],score[zax[k]],pch=ig,cex=1,col=ig)
}

layout(1)

dev.off()

pff<-NULL
for (ji in jvb){
o<-summary(lm(formula(paste("v1650~",ji,"+pdens+factor(v858):pdens",sep="")),data=m9))
bet<-as.matrix(coef(o)[tbs,1],length(tbs),1)
score<-dums%*%bet
pff<-rbind(pff,as.numeric(cor(score,m9$pdens)))
}
rownames(pff)<-jvb
pff<-cbind(pff[order(pff),])

Atf(pff,"tabs",TRUE)

sccsA$pdens<-apply((sccsA[,c("v64","v156","v1130")]),1,mean)
cor(sccsA$v1650,sccsA$pdens,use="pair")



